# Class BioShape

java.lang.Object
org.jmol.shape.Shape
org.jmol.shape.AtomShape
org.jmol.shapebio.BioShape

public class BioShape extends AtomShape

## Field Summary

Fields
Modifier and Type
Field
Description
`BioPolymer`
`bioPolymer`
`short[]`
`colixesBack`
`Mesh[]`
`meshes`
`boolean[]`
`meshReady`
`int`
`modelIndex`
`int`
`modelVisibilityFlags`
`Monomer[]`
`monomers`
`V3[]`
`wingVectors`

### Fields inherited from class AtomShape

`bsSizeDefault, colixes, isActive, isSet, mad, mads, monomerCount, paletteIDs`

### Fields inherited from class Shape

`bsColixSet, bsSizeSet, isBioShape, ms, myType, RADIUS_MAX, shapeID, translucentAllowed, translucentLevel, vf, vwr`

## Method Summary

Modifier and Type
Method
Description
`void`
`falsifyMesh()`
`void`
`findNearestAtomIndex(int xMouse, int yMouse, Atom[] closest, BS bsNot)`
`String`
`getShapeState()`
`void`
`setAtomClickability()`
`void`
`setParams(Object[] data, int[] atomMap, BS bsSelected)`
`void`
`setProperty(String propertyName, Object value, BS bsSelected)`

### Methods inherited from class AtomShape

`checkColixLength, getSize, initModelSet, initShape, setColixAndPalette, setPropAS, setSize, setSize2, setSizeRD, setSizeRD2`

### Methods inherited from class Shape

`appendCmd, checkBoundsMinMax, checkObjectClicked, checkObjectDragged, checkObjectHovered, coordinateInRange, encodeColor, getColix, getColixA, getColixB, getColixI, getColorCommand, getColorCommandUnk, getFontCommand, getIndexFromName, getProperty, getPropertyData, getPropShape, getShapeDetail, getSizeG, getTranslucentLabel, initializeShape, replaceGroup, setModelSet, setModelVisibilityFlags, setProperties, setPropS, setShapeSizeRD, wasClicked`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### modelIndex

public int modelIndex

### modelVisibilityFlags

public int modelVisibilityFlags

### bioPolymer

public BioPolymer bioPolymer

### meshes

public Mesh[] meshes

### meshReady

public boolean[] meshReady

### colixesBack

public short[] colixesBack

### monomers

public Monomer[] monomers

### wingVectors

public V3[] wingVectors

## Method Details

### setProperty

public void setProperty(String propertyName, Object value, BS bsSelected)

Specified by:
  `setProperty` in class `Shape`

### findNearestAtomIndex

public void findNearestAtomIndex(int xMouse, int yMouse, Atom[] closest, BS bsNot)

Overrides:
  `findNearestAtomIndex` in class `Shape`
Parameters:
  `xMouse` -
  `yMouse` -
  `closest` -
  `bsNot` -

### falsifyMesh

public void falsifyMesh()

### setParams

public void setParams(Object[] data, int[] atomMap, BS bsSelected)

### setAtomClickability

public void setAtomClickability()

Overrides:
  `setAtomClickability` in class `AtomShape`

### getShapeState

public String getShapeState()

Overrides:
  `getShapeState` in class `AtomShape`